//+------------------------------------------------------------------+
//|                                                     SMA_Test.mq4 |
//|                                   Copyright  2008, Kevin Naidoo |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kevin Naidoo"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Coral
//---- indicator parameters
extern int epPeriod = 0;
extern int epAveragingPeriod1 = 3;
extern int epAveragingPeriod2 = 5;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   string short_name = "SMA("+epAveragingPeriod1+")-SMA("+epAveragingPeriod2+") ("+epPeriod+") ";
   IndicatorShortName(short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   int pos=Bars-counted_bars;
   //---- main calculation loop
   for(int i=0; i<pos; i++)
   {     
     ExtMapBuffer1[i] = iMA(Symbol(), epPeriod, epAveragingPeriod1, 0, 0, PRICE_OPEN, i) - iMA(Symbol(), epPeriod, epAveragingPeriod2, 3, 0, PRICE_OPEN, i);
     //Comment("SMA(", epAveragingPeriod1, ")-SMA(", epAveragingPeriod2, ") = ", ExtMapBuffer1[i]);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+